AWSTemplateFormatVersion: '2010-09-09'
Transform: AWS::Serverless-2016-10-31
Description: >
  handbook-backend

  Sample SAM Template for handbook-backend
  
# More info about Globals: https://github.com/awslabs/serverless-application-model/blob/master/docs/globals.rst
Globals:
  Function:
    Timeout: 10

Resources:
  HandbookNotificationsFunction:
    Type: AWS::Serverless::Function # More info about Function Resource: https://github.com/awslabs/serverless-application-model/blob/master/versions/2016-10-31.md#awsserverlessfunction
    Properties:
      MemorySize: 256
      Policies: 
      - Version: '2012-10-17'
        Statement:
        - Effect: Allow
          Action:
          - 's3:GetObject'
          Resource: 'arn:aws:s3:::Handbook-Prod'
      CodeUri: notifications/
      Handler: app.lambdaHandler
      Runtime: nodejs18.x
      Architectures:
        - x86_64
      Events:
        HandbookNotifications:
          Type: Api # More info about API Event Source: https://github.com/awslabs/serverless-application-model/blob/master/versions/2016-10-31.md#api
          Properties:
            Path: /notifications
            Method: get
    Metadata: # Manage esbuild properties
      BuildMethod: esbuild
      BuildProperties:
        Minify: true
        Target: "es2020"
        Sourcemap: true
        EntryPoints: 
        - app.ts
  SiteMapFunction:
    Type: AWS::Serverless::Function # More info about Function Resource: https://github.com/awslabs/serverless-application-model/blob/master/versions/2016-10-31.md#awsserverlessfunction
    Properties:
      MemorySize: 256
      Policies: 
      - Version: '2012-10-17'
        Statement:
        - Effect: Allow
          Action:
          - 's3:GetObject'
          Resource: 'arn:aws:s3:::Handbook-Prod'
      CodeUri: sitemap/
      Handler: app.lambdaHandler
      Runtime: nodejs18.x
      Architectures:
        - x86_64
      Events:
        HandbookNotifications:
          Type: Api # More info about API Event Source: https://github.com/awslabs/serverless-application-model/blob/master/versions/2016-10-31.md#api
          Properties:
            Path: /sitemap
            Method: get
    Metadata: # Manage esbuild properties
      BuildMethod: esbuild
      BuildProperties:
        Minify: true
        Target: "es2020"
        Sourcemap: true
        EntryPoints: 
        - app.ts

Outputs:
  # ServerlessRestApi is an implicit API created out of Events key under Serverless::Function
  # Find out more about other implicit resources you can reference within SAM
  # https://github.com/awslabs/serverless-application-model/blob/master/docs/internals/generated_resources.rst#api
  HandbookNotificationsApi:
    Description: "API Gateway endpoint URL for Prod stage for Handbook Notifications function"
    Value: !Sub "https://${ServerlessRestApi}.execute-api.${AWS::Region}.amazonaws.com/Prod/notifications/"
  HandbookNotificationsFunction:
    Description: "Handbook Notifications Lambda Function ARN"
    Value: !GetAtt HandbookNotificationsFunction.Arn
  HandbookNotificationsFunctionIamRole:
    Description: "Implicit IAM Role created for Handbook Notifications function"
    Value: !GetAtt HandbookNotificationsFunctionRole.Arn
  HandbookSiteMapApi:
    Description: "API Gateway endpoint URL for Prod stage for Handbook Sitemap function"
    Value: !Sub "https://${ServerlessRestApi}.execute-api.${AWS::Region}.amazonaws.com/Prod/sitemap/"
  HandbookSiteMapFunction:
    Description: "Handbook Sitemap Lambda Function ARN"
    Value: !GetAtt HandbookSiteMapFunction.Arn
  HandbookSiteMapFunctionIamRole:
    Description: "Implicit IAM Role created for Handbook SiteMap function"
    Value: !GetAtt HandbookSiteMapFunction.Arn
